// things for files and more
rawset(_G, "X_AvailableButtons", {
	["CUSTOM3"] = BT_CUSTOM3,
	["TOSSFLAG"] = BT_TOSSFLAG,
	["FIRENORMAL"] = BT_FIRENORMAL,
	["FIRE"] = BT_ATTACK
})

rawset(_G, "X_Buttons", {
	[BT_CUSTOM1] = "CUSTOM1",
	[BT_CUSTOM2] = "CUSTOM2",
	[BT_CUSTOM3] = "CUSTOM3",
	[BT_USE] = "SPIN",
	[BT_JUMP] = "JUMP",
	[BT_ATTACK] = "ATTACK",
	[BT_FIRENORMAL] = "FIRENORMAL",
	[BT_WEAPONNEXT] = "WEAPONNEXT",
	[BT_WEAPONPREV] = "WEAPONPREV",
	[BT_CAMLEFT] = "CAMLEFT",
	[BT_CAMRIGHT] = "CAMRIGHT"
})

rawset(_G, "X_SetMenuButton", function(p, button)
	if X_AvailableButtons[button]
		p.menuButton = X_AvailableButtons[button]
	end
end)

rawset(_G, "X_ButtonToString", function(button)
	return X_Buttons[button]
end)

rawset(_G, "X_Characters", {
	["sonic"] = true,
	["tails"] = true,
	["knuckles"] = true,
	["amy"] = false,
	["fang"] = false,
	["metalsonic"] = false
})

rawset(_G, "X_BoolToString", function(bool)
	if bool
		return "on"
	else
		return "off"
	end
end)

rawset(_G, "X_BoolToNumString", function(bool)
	if bool
		return "1"
	else
		return "0"
	end
end)

rawset(_G, "X_BoolToNum", function(bool)
	if bool
		return 1
	else
		return 0
	end
end)

rawset(_G, "X_NumToBool", function(num)
	if num >= 1
		return true
	else
		return false
	end
end)

rawset(_G, "X_StringToBool", function(string)
	if string == "1" or string == "on" or string == "true"
		return true
	elseif string == "0" or string == "off" or string == "false"
		return false
	end
end)

local XCharAbilities = "client/xcell/XCharAbilities.cfg"
local XCellPrefs = "client/xcell/XCellPrefs.cfg"

local function updateSaveFiles(p)
	if io and p == consoleplayer
		local peelout, launch, drill, walldash, glidedash
		if p.peeloutAvailable then peelout = "on" else peelout = "off" end
		if p.launchAvailable then launch = "on" else launch = "off" end
		if p.drillAvailable then drill = "on" else drill = "off" end
		if p.walldashAvailable then walldash = "on" else walldash = "off" end
		if p.glidedashAvailable then glidedash = "on" else glidedash = "off" end
		
		local file = io.openlocal(XCharAbilities, "w+")
		file:write("abilitytoggle sonic peelout "..tostring(peelout)..
			"\nabilitytoggle tails launch "..tostring(launch)..
			"\nabilitytoggle knuckles drill "..tostring(drill)..
			"\nabilitytoggle knuckles walldash "..tostring(walldash)..
			"\nabilitytoggle knuckles glidedash "..tostring(glidedash)
		)
		
		local springflips, boostmechanic, xcellhud, zoomonboost, deatheffect
		if p.springFlips then springflips = "on" else springflips = "off" end
		if p.boostMechanic then boostmechanic = "on" else boostmechanic = "off" end
		if p.XCellHud then xcellhud = "on" else xcellhud = "off" end
		if p.camZoomOnBoost then zoomonboost = "on" else zoomonboost = "off" end
		if p.deathEffect then deatheffect = "on" else deatheffect = "off" end
		
		local file2 = io.openlocal(XCellPrefs, "w+")
		file2:write("springflips "..tostring(springflips)..
			"\nboostmechanic "..tostring(boostmechanic)..
			"\nxcellhud "..tostring(xcellhud)..
			"\nzoomonboost "..tostring(zoomonboost)..
			"\ndeatheffect "..tostring(deatheffect)
		)
	else
		CONS_Printf(p, "\x85" + "ERROR:" + "\x82" + "Something went wrong, not really sure how you got here..")
	end
end

local savesloaded = false
local function loadSaveFiles()
	local file, file2
	local p = consoleplayer
	if not savesloaded then
		file = io.openlocal(XCharAbilities, "r")
		file2 = io.openlocal(XCellPrefs, "r")
		
		CONS_Printf(p, "\x82" + "Loading save files..")
		
		if file and file2 then
			if not p then
				CONS_Printf(p, "\x85" + "ERROR:" + "\x82" + "Player doesn't exist, save files cannot be loaded.")
				savesloaded = true
				return
			end
			
			local value, value2
			value = file:read()
			value2 = file2:read()
			
			while value do
				COM_BufInsertText(p, value)
				value = file:read()
			end
			
			while value2 do
				COM_BufInsertText(p, value2)
				value2 = file2:read()
			end
			
			CONS_Printf(p, "\x88" + "Save files have been loaded!")
			
			file:close()
			file2:close()
		else
			file = io.openlocal(XCharAbilities, "w")
			file2 = io.openlocal(XCellPrefs, "w")
			
			if not file or not file2
				CONS_Printf(p, "\x85" + "ERROR:" + "\x82" + "One of the save files couldn't be created.")
				savesloaded = true
			end
			
			CONS_Printf(p, "\x83" + "XCell save files have been created!")
			
			file:close()
			file2:close()
		end
		savesloaded = true
	end
end

addHook("ThinkFrame", function()
    for p in players.iterate do
		if p.peeloutAvailable == nil
			p.peeloutAvailable = true
		end
		
		if p.launchAvailable == nil
			p.launchAvailable = true
		end
		
		if p.walldashAvailable == nil
			p.walldashAvailable = true
		end
		
		if p.drillAvailable == nil
			p.drillAvailable = true
		end
		
		if p.glidedashAvailable == nil
			p.glidedashAvailable = true
		end
		
		if p.boostMechanic == nil
			p.boostMechanic = true
		end
		
		if p.springFlips == nil
			p.springFlips = true
		end
		
		if p.XCellHud == nil
			p.XCellHud = true
		end
		
		if p.camZoomOnBoost == nil
			p.camZoomOnBoost = false
		end
		
		if p.deathEffect == nil
			p.deathEffect = false
		end
		
		loadSaveFiles()
	end
end)

COM_AddCommand("xcellcommands", function(p, arg)
	CONS_Printf(p, "List of commands:")
	CONS_Printf(p, "abilitytoggle")
	CONS_Printf(p, "springflips")
	CONS_Printf(p, "boostmechanic")
	CONS_Printf(p, "xcellhud")
	CONS_Printf(p, "zoomonboost")
	CONS_Printf(p, "deatheffect")
end)

COM_AddCommand("abilitytoggle", function(p, arg1, arg2, arg3)
	if p and p.mo and p.mo.valid
		if arg1 == nil or arg1 == "" or arg1 == "help"
			CONS_Printf(p, "Argument 1: Character to toggle ability of")
			CONS_Printf(p, "Argument 2: Ability to toggle\n")
			CONS_Printf(p, "This will turn on or off any ability of the base characters")
		elseif X_Characters[arg1]
			if arg1 == "sonic"
				if arg2 == "peelout"
					if not arg3
						p.peeloutAvailable = not p.peeloutAvailable
					else
						p.peeloutAvailable = X_StringToBool(arg3)
					end
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.peeloutAvailable))
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Peelout")
				else
					CONS_Printf(p, "Not an ability!")
				end
			elseif arg1 == "tails"
				if arg2 == "launch"
					if not arg3
						p.launchAvailable = not p.launchAvailable
					else
						p.launchAvailable = X_StringToBool(arg3)
					end
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.launchAvailable))
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Launch")
				else
					CONS_Printf(p, "Not an ability!")
				end
			elseif arg1 == "knuckles"
				if arg2 == "walldash"
					if not arg3
						p.walldashAvailable = not p.walldashAvailable
					else
						p.walldashAvailable = X_StringToBool(arg3)
					end
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.walldashAvailable))
				elseif arg2 == "drill"
					if not arg3
						p.drillAvailable = not p.drillAvailable
					else
						p.drillAvailable = X_StringToBool(arg3)
					end
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.drillAvailable))
				elseif arg2 == "glidedash"
					if not arg3
						p.glidedashAvailable = not p.glidedashAvailable
					else
						p.glidedashAvailable = X_StringToBool(arg3)
					end
					
					CONS_Printf(p, "Ability is now toggled " + X_BoolToString(p.glidedashAvailable))
				elseif arg2 == "abilities" or arg2 == nil
					CONS_Printf(p, "Walldash")
					CONS_Printf(p, "Drill")
					CONS_Printf(p, "Glidedash")
				else
					CONS_Printf(p, "Not an ability!")
				end
				
				if arg2
					updateSaveFiles(p)
				end
			end
		elseif not X_Characters[arg1]
			CONS_Printf(p, "Not a valid character!")
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("springflips", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.springFlips = true
			CONS_Printf(p, "You can now flip on springs")
		elseif arg == "0" or arg == "off" or arg == "false"
			p.springFlips = false
			CONS_Printf(p, "Spring flips are off")
		else
			CONS_Printf(p, "Choose whether or not your character can flip on springs")
		end
		
		if arg
			updateSaveFiles(p)
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("boostmechanic", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.boostMechanic = true
			CONS_Printf(p, "Boost mechanic is on")
		elseif arg == "0" or arg == "off" or arg == "false"
			p.boostMechanic = false
			CONS_Printf(p, "Boost mechanic is off")
		else
			CONS_Printf(p, "Turns on or off the boost mechanic for the mod")
		end
		
		if arg
			updateSaveFiles(p)
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("xcellhud", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.XCellHud = true
			CONS_Printf(p, "Custom HUD is on")
		elseif arg == "0" or arg == "off" or arg == "false"
			p.XCellHud = false
			CONS_Printf(p, "Custom HUD is off")
		else
			CONS_Printf(p, "Toggles the custom HUD for the mod on or off")
		end
		
		if arg
			updateSaveFiles(p)
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("zoomonboost", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.camZoomOnBoost = true
			CONS_Printf(p, "Camera now zooms in when boost is at max")
		elseif arg == "0" or arg == "off" or arg == "false"
			p.camZoomOnBoost = false
			CONS_Printf(p, "The camera will not zoom when boost is at max")
		else
			CONS_Printf(p, "Toggles if the camera will zoom in or not when boost meter is full")
		end
		
		if arg
			updateSaveFiles(p)
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

COM_AddCommand("deatheffect", function(p, arg)
	if p and p.mo and p.mo.valid
		if arg == "1" or arg == "on" or arg == "true"
			p.deathEffect = true
			CONS_Printf(p, "kinda funny death effect is on")
		elseif arg == "0" or arg == "off" or arg == "false"
			p.deathEffect = false
			CONS_Printf(p, "Death effect is off")
		else
			CONS_Printf(p, "Toggles the XCell death effect")
		end
		
		if arg
			updateSaveFiles(p)
		end
	else
		CONS_Printf(p, "You aren't in-game!")
	end
end)

// this was so infuriating to make im probably not bringing it back
/*COM_AddCommand("menubutton", function(p, arg) 
	if p and p.mo and p.mo.valid
		if X_AvailableButtons[arg]
			X_SetMenuButton(p, arg)
			CONS_Printf(p, "Menu button set to " + arg)
		elseif arg
			CONS_Printf(p, "Not an available button!")
		elseif arg == nil or arg == "" or arg == "help"
			CONS_Printf(p, "Sets the button to use when opening the settings menu")
			CONS_Printf(p, "\nList of available buttons:" + "\nCUSTOM3\nTOSSFLAG\nFIRENORMAL\nFIRE")
			CONS_Printf(p, "\nCurrent button is: " + X_ButtonToString(p.menuButton))
		end
	end
end)*/