local frac = FRACUNIT

rawset(_G, "X_SpawnRingEffect", function(p) // ring effect for the last boost
	local ring = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BRING)
	ring.angle = p.mo.angle + ANGLE_90
	ring.fuse = 7
	ring.scalespeed = frac/2
	ring.scale = 2*frac/3
	ring.destscale = 6*frac
	ring.color = p.mo.color
	ring.blendmode = AST_ADD
end)

rawset(_G, "X_SpawnThokTrail", function(p) // self explanatory
	local trail = P_SpawnMobjFromMobj(p.mo, 0, 0, -7*frac, MT_THOK)
	trail.color = p.mo.color
	trail.scalespeed = frac/6
	trail.destscale = frac/10
	trail.fuse = 7
	trail.blendmode = AST_ADD
end)

rawset(_G, "X_SpawnGhostTrail", function(p, scale, colorize)
	local ghost = P_SpawnGhostMobj(p.mo)
	ghost.z = p.mo.z
	ghost.fuse = 7
	ghost.scalespeed = frac/6
	ghost.scale = frac
	ghost.color = p.mo.color
	ghost.colorized = colorize
	ghost.destscale = frac-scale
	
	local tracer = ghost.tracer
	
	if tracer
		tracer.z = ghost.z
		tracer.fuse = ghost.fuse
		tracer.scalespeed = ghost.scalespeed
		tracer.scale = ghost.scale
		tracer.color = ghost.color
		tracer.colorized = ghost.colorized
		tracer.destscale = ghost.destscale
	end
end)

rawset(_G, "X_SpawnGhostTrailAdd", function(p, scale, colorize)
	local ghost = P_SpawnGhostMobj(p.mo)
	ghost.z = p.mo.z
	ghost.fuse = 7
	ghost.scalespeed = frac/6
	ghost.scale = frac
	ghost.color = p.mo.color
	ghost.colorized = colorize
	ghost.destscale = frac-scale
	ghost.blendmode = AST_ADD
	
	local tracer = ghost.tracer
	
	if tracer
		tracer.z = ghost.z
		tracer.fuse = ghost.fuse
		tracer.scalespeed = ghost.scalespeed
		tracer.scale = ghost.scale
		tracer.color = ghost.color
		tracer.colorized = ghost.colorized
		tracer.destscale = ghost.destscale
		tracer.blendmode = ghost.blendmode
	end
end)

rawset(_G, "X_SpawnAura", function(p)
	local aura = P_SpawnGhostMobj(p.mo)
	aura.z = p.mo.z
	aura.fuse = 2
	aura.scalespeed = frac
	aura.scale = frac
	aura.color = SKINCOLOR_WHITEAURA
	aura.colorized = true
	aura.destscale = 10*frac/9
	aura.dispoffset = -1
	
	local tracer = aura.tracer
	
	if tracer
		tracer.z = aura.z
		tracer.fuse = aura.fuse
		tracer.scalespeed = aura.scalespeed
		tracer.scale = aura.scale
		tracer.color = aura.color
		tracer.colorized = aura.colorized
		tracer.destscale = aura.destscale
		tracer.dispoffset = aura.dispoffset
	end
end)

rawset(_G, "P_CheckForLava", function(p) // probably shoulda kept this in sonic's script
	if p.mo.floorrover
		if P_CheckSolidLava(p.mo, p.mo.floorrover)
			return true
		else
			return false
		end
	else
		return false
	end
end)

