local frac = FRACUNIT

addHook("ThinkFrame", function()
	for p in players.iterate
		if not (p and p.mo and p.mo.valid and p.mo.skin == "sonic") then return end
		
		// reset thoks
		if P_IsObjectOnGround(p.mo)
		and p.thokked
			p.thokked = 0
		end
		
		// peelout (this might be difficult i remember it not working last time)
		if P_IsObjectOnGround(p.mo) // checks if you can peelout
		and p.playerstate ~= PST_DEAD
		and p.speed <= 5*frac
		and not p.exiting
		and not p.nightstime
		and p.peeloutAvailable
			p.canPeel = true
		else
			p.canPeel = false
		end
		
		if (p.cmd.buttons & BT_CUSTOM1) // makes you stand still
		and p.canPeel
			p.pflags = $1|PF_STASIS
			p.peelStart = true
			p.peelTime = $ + 1
			p.speed = 0
		end
		
		if (p.cmd.buttons & BT_JUMP) // if you jump it takes you out
		and p.peelStart
			p.pflags = $1 & ~PF_STASIS
			p.canPeel = false
			p.peelStart = false
			p.peelTime = 0
		end
		
		if p.peelTime > 50 // cap
			p.peelTime = 50
		end
		
		if p.peelTime == 1 // starting sfx
			S_StartSound(p.mo, sfx_chrg)
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) // launch
		and not p.exiting
		and p.peelTime > 15
		and not p.peelingOut
		and p.peelStart
			if p.powers[pw_super]
				if p.powers[pw_underwater]
					P_InstaThrust(p.mo, p.mo.angle, (p.peelTime*(frac+frac/2)) - frac/3)
				else
					P_InstaThrust(p.mo, p.mo.angle, p.peelTime*(frac+frac/2))
				end
			else
				if p.powers[pw_underwater]
					P_InstaThrust(p.mo, p.mo.angle, (p.peelTime*(frac+frac/4)) - frac/3)
				else
					P_InstaThrust(p.mo, p.mo.angle, p.peelTime*(frac+frac/4))
				end
			end
			S_StartSound(p.mo, sfx_peel)
			p.pflags = $1 & ~PF_STASIS
			p.peelingOut = true
			p.peelStart = false
			p.peelTime = 0
		end
		
		if not (p.cmd.buttons & BT_CUSTOM1) // reset peeltime
		or p.exiting
			p.peelTime = 0
		end
		
		if p.peelingOut // turn it off instantly
			p.peelingOut = false
		end
		
		if p.speed > 60*frac // dash anim
			if p.mo.state == S_PLAY_RUN
				p.mo.state = S_PLAY_DASH
			end
		else
			if p.mo.state == S_PLAY_DASH
				p.mo.state = S_PLAY_RUN
			end
		end
		
		if p.speed > 0 // change the anim
		and (p.mo.state == S_PLAY_PEEL1 
		or p.mo.state == S_PLAY_PEEL2 
		or p.mo.state == S_PLAY_PEEL3 
		or p.mo.state == S_PLAY_PEEL4)
			p.mo.state = S_PLAY_DASH
		end
		
		if p.peelTime <= 35 and p.peelTime > 0 // peelout anim (from peelout script by MotdSpork)
			if not (p.mo.state >= S_PLAY_PWALK1)
			and (p.mo.state <= S_PLAY_PWALK16)
				p.mo.state = S_PLAY_PWALK1
			end
		elseif p.peelTime > 35
			if not ((p.mo.state >= S_PLAY_PEEL1) and (p.mo.state <= S_PLAY_PEEL4))
			or ((p.mo.state >= S_PLAY_PWALK1) and (p.mo.state <= S_PLAY_PWALK16))
				p.mo.state = S_PLAY_PEEL1
			end
		end
		
		if p.peelTime >= 10
			P_SpawnSkidDust(p, 15*frac)
		end
		
		if (p.mo.state == S_PLAY_PWALK1 // WHY
		or p.mo.state == S_PLAY_PWALK2 
		or p.mo.state == S_PLAY_PWALK3 
		or p.mo.state == S_PLAY_PWALK4
		or p.mo.state == S_PLAY_PWALK5 
		or p.mo.state == S_PLAY_PWALK6 
		or p.mo.state == S_PLAY_PWALK7
		or p.mo.state == S_PLAY_PWALK8 
		or p.mo.state == S_PLAY_PWALK9 
		or p.mo.state == S_PLAY_PWALK10
		or p.mo.state == S_PLAY_PWALK11 
		or p.mo.state == S_PLAY_PWALK12 
		or p.mo.state == S_PLAY_PWALK13
		or p.mo.state == S_PLAY_PWALK14 
		or p.mo.state == S_PLAY_PWALK15 
		or p.mo.state == S_PLAY_PWALK16)
		and p.peelTime == 0
		and p.speed == 0
			S_StopSoundByID(p.mo, sfx_chrg)
			p.mo.state = S_PLAY_STND
		end
	end
end)

addHook("PlayerThink", function(p)
	if p.mo.skin == "sonic"
		// thing
		if (p.cmd.buttons & BT_JUMP) // brings you down if youre holding
		and p.thokked == 2
			p.mo.momz = $ - 2*frac
			p.dropping = true
		end
		
		if not (p.cmd.buttons & BT_JUMP) // sets thokked to 3 if not holding
		and p.dropping
			p.dropping = false
			p.thokked = 3
		end
		
		if P_IsObjectOnGround(p.mo) // hit ground
		and not P_CheckForLava(p)
		and not P_CheckDeathPitCollide(p.mo)
		and p.dropping
			if p.powers[pw_super]
				P_StartQuake(30*frac, 2)
				P_SetObjectMomZ(p.mo, 16*frac, false)
				P_NukeEnemies(p.mo, p.mo, 600*frac)
			else
				P_SetObjectMomZ(p.mo, 12*frac, false)
				P_NukeEnemies(p.mo, p.mo, 400*frac)
			end
			S_StartSound(p.mo, sfx_s3k49)
			p.mo.state = S_PLAY_SPRING
			p.pflags = $1 & ~PF_JUMPED
			p.dropping = false
			p.thokked = 0
		end
		
		if p.dropping // reset dropping
		and p.mo.state ~= S_PLAY_ROLL
			p.pflags = $1 & ~PF_JUMPED
			p.dropping = false
			p.thokked = 0
		end
		
		if p.dropping // set power flags
			p.powers[pw_strong] = $1|STR_SPRING|STR_FLOOR
		else
			p.powers[pw_strong] = $ & ~STR_SPRING & ~STR_FLOOR
		end
		
		if P_PlayerInPain(p)
		and p.playerstate ~= PST_LIVE
			p.pflags = $1 & ~PF_JUMPED
			p.dropping = false
			p.thokked = 0
		end
		
		if p.mo.state ~= S_PLAY_ROLL // resets p.thokking
		and p.thokking
			p.thokking = false
		end
	end
end)

addHook("TouchSpecial", function(mobj, pmo)
	if pmo.skin ~= "sonic" return end
	
	local p = pmo.player
	
    if p.thokked == 2 and (mobj.flags & MF_ENEMY)
		P_SetObjectMomZ(p.mo, abs(pmo.momz)/2 + 5*frac, false)
        P_KillMobj(mobj, pmo, pmo)
		p.pflags = $1 & ~PF_THOKKED
		p.dropping = false
		p.thokked = 1
    end
end)

// code base by clairebun because apparently i fuckking suck at coding thoks
addHook("AbilitySpecial", function(p)
	if p.mo.skin != "sonic" return end
	if p.pflags & PF_THOKKED return true end
	
	local actionspd = FixedMul(p.mo.scale, p.actionspd)
	
	if p.mo.eflags & MFE_UNDERWATER
		actionspd = $/2
	end
	
	if p.thokked == 0
		P_InstaThrust(p.mo, p.mo.angle, actionspd)
		P_SetObjectMomZ(p.mo, p.speed/6 + 2*frac, false)
		P_SpawnThokMobj(p)
		S_StartSound(p.mo, sfx_thok)
		p.mo.state = S_PLAY_ROLL
		p.thokking = true
		p.thokked = 1
	elseif p.thokked == 1
		P_InstaThrust(p.mo, p.mo.angle, actionspd)
		P_SetObjectMomZ(p.mo, p.speed/6 + 12*frac, false)
		P_SpawnThokMobj(p)
		S_StartSound(p.mo, sfx_thok)
		S_StartSound(p.mo, sfx_zoom)
		p.mo.state = S_PLAY_ROLL
		p.pflags = $|PF_THOKKED
		p.thokking = true
		p.thokked = 2
	end
	
	return true
end)

